From 3b86b7620c06d3402f01b4903c6ae6ac8b510fcf Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Wed, 27 Mar 2013 14:28:31 -0400
Subject: [PATCH] Updated version number to 10.0.2-0.1.

The compose scripts and RPM specs have been updated to use version
10.0.2-0.1. The CMake script has been fixed to use the correct
version number.
---
 CMakeLists.txt                            |  4 +-
 scripts/compose_dogtag_pki_theme_packages |  2 +-
 scripts/compose_ipa_pki_theme_packages    |  2 +-
 scripts/compose_pki_console_packages      |  2 +-
 scripts/compose_pki_core_packages         |  2 +-
 scripts/compose_pki_migrate_packages      |  2 +-
 scripts/compose_pki_ra_packages           |  2 +-
 scripts/compose_pki_tps_packages          |  2 +-
 specs/dogtag-pki-theme.spec               |  7 ++-
 specs/dogtag-pki.spec                     | 87 ++++++++++++++++---------------
 specs/ipa-pki-theme.spec                  |  7 ++-
 specs/pki-console.spec                    |  7 ++-
 specs/pki-core.spec                       |  7 ++-
 specs/pki-migrate.spec                    |  7 ++-
 specs/pki-ra.spec                         |  7 ++-
 specs/pki-tps.spec                        |  7 ++-
 16 files changed, 89 insertions(+), 65 deletions(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 6462ca379f13093553168161c7a96aa462145ec6..297c387cc15861809cf3c2d20f311159baeeb8d8 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -6,9 +6,9 @@ cmake_minimum_required(VERSION 2.6.0)
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
 
-if (NOT DEFINED ${VERSION})
+if (NOT DEFINED VERSION)
     set(VERSION "10.0.0")
-endif(NOT DEFINED ${VERSION})
+endif(NOT DEFINED VERSION)
 
 string(REGEX REPLACE "^([0-9]+).*" "\\1" APPLICATION_VERSION_MAJOR ${VERSION})
 string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*" "\\1" APPLICATION_VERSION_MINOR ${VERSION})
diff --git a/scripts/compose_dogtag_pki_theme_packages b/scripts/compose_dogtag_pki_theme_packages
index e98c2b2777ffe5bfbe68f0864e65599e738b82e1..6c21cf3b3fb14b568461cb34853dfe31df63b6f8 100755
--- a/scripts/compose_dogtag_pki_theme_packages
+++ b/scripts/compose_dogtag_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 DOGTAG_PKI_THEME="dogtag-pki-theme"
-DOGTAG_PKI_THEME_VERSION="10.0.0"
+DOGTAG_PKI_THEME_VERSION="10.0.2"
 
 
 ##
diff --git a/scripts/compose_ipa_pki_theme_packages b/scripts/compose_ipa_pki_theme_packages
index 4d4ec909d3c59bad784f39a158d1fbbd3de57fc1..1158ccbbb00e2523bf304b82807b1ef7af5ca941 100755
--- a/scripts/compose_ipa_pki_theme_packages
+++ b/scripts/compose_ipa_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 IPA_PKI_THEME="ipa-pki-theme"
-IPA_PKI_THEME_VERSION="10.0.0"
+IPA_PKI_THEME_VERSION="10.0.2"
 
 
 ##
diff --git a/scripts/compose_pki_console_packages b/scripts/compose_pki_console_packages
index f126d9c4d734a3883ff6d96143a240e09e401ede..99624fd1c9b816ab4203d3209f83d848d5838d45 100755
--- a/scripts/compose_pki_console_packages
+++ b/scripts/compose_pki_console_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CONSOLE="pki-console"
-PKI_CONSOLE_VERSION="10.0.0"
+PKI_CONSOLE_VERSION="10.0.2"
 
 
 ##
diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index 76a77043008b63db54cb9314aa6bc9ad75824ced..0ecbdb533a9cd83051a2d2f83b3c607207bf1ef8 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CORE="pki-core"
-PKI_CORE_VERSION="10.0.1"
+PKI_CORE_VERSION="10.0.2"
 
 
 ##
diff --git a/scripts/compose_pki_migrate_packages b/scripts/compose_pki_migrate_packages
index f7d4eae814a9e8c99b790d4c76248877ec001f44..eea5837c7d0805d10d59a05e7872929475cde3d6 100755
--- a/scripts/compose_pki_migrate_packages
+++ b/scripts/compose_pki_migrate_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_MIGRATE="pki-migrate"
-PKI_MIGRATE_VERSION="10.0.0"
+PKI_MIGRATE_VERSION="10.0.2"
 
 
 ##
diff --git a/scripts/compose_pki_ra_packages b/scripts/compose_pki_ra_packages
index 0b603eac1d76737151c3e3f4abd8393ddb810016..923095765c313e2008fd6ae99118908cdf0a7c5f 100755
--- a/scripts/compose_pki_ra_packages
+++ b/scripts/compose_pki_ra_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_RA="pki-ra"
-PKI_RA_VERSION="10.0.0"
+PKI_RA_VERSION="10.0.2"
 
 
 ##
diff --git a/scripts/compose_pki_tps_packages b/scripts/compose_pki_tps_packages
index 79d9c91464da40945026335624fc57290991991d..5e832d6ec9e52a22b779660f29b4a937308d77e2 100755
--- a/scripts/compose_pki_tps_packages
+++ b/scripts/compose_pki_tps_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_TPS="pki-tps"
-PKI_TPS_VERSION="10.0.0"
+PKI_TPS_VERSION="10.0.2"
 
 
 ##
diff --git a/specs/dogtag-pki-theme.spec b/specs/dogtag-pki-theme.spec
index 9c59968d3e291e7cc7b4903c993dc77db054f6ff..07498c12a2b47851d8ff556b75cd9aa45e3f2551 100644
--- a/specs/dogtag-pki-theme.spec
+++ b/specs/dogtag-pki-theme.spec
@@ -1,6 +1,6 @@
 Name:             dogtag-pki-theme
-Version:          10.0.0
-Release:          1%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Certificate System - Dogtag PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -217,6 +217,9 @@ cd build
 
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Fri Dec 7 2012 Ade Lee <alee@redhat.com> 10.0.0-1
 - Update to official release for rc1
 
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index 75696e9b1087d79d225b163e14f7db2fa613436e..6dfb12d7ea01cad0549b1554a1ed1c227b346c3e 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -1,7 +1,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
-Version:          10.0.1
-Release:          2%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -11,67 +11,67 @@ BuildArch:        noarch
 
 # Establish MINIMUM package versions based upon platform
 %if 0%{?rhel} || 0%{?fedora} >= 19
-%define dogtag_pki_theme_version   10.0.0
+%define dogtag_pki_theme_version   10.0.2
 %define esc_version                1.1.0
 %define jss_version                4.2.6-28
-%define pki_core_version           10.0.1
-%define pki_kra_version            10.0.0
-%define pki_ocsp_version           10.0.0
-%define pki_ra_version             10.0.0
-%define pki_tks_version            10.0.0
-%define pki_tps_version            10.0.0
-%define pki_console_version        10.0.0
+%define pki_core_version           10.0.2
+%define pki_kra_version            10.0.2
+%define pki_ocsp_version           10.0.2
+%define pki_ra_version             10.0.2
+%define pki_tks_version            10.0.2
+%define pki_tps_version            10.0.2
+%define pki_console_version        10.0.2
 %define tomcatjss_version          7.1.0
 %else
 %if 0%{?fedora} >= 18
-%define dogtag_pki_theme_version   10.0.0
+%define dogtag_pki_theme_version   10.0.2
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.1
-%define pki_kra_version            10.0.0
-%define pki_ocsp_version           10.0.0
-%define pki_ra_version             10.0.0
-%define pki_tks_version            10.0.0
-%define pki_tps_version            10.0.0
-%define pki_console_version        10.0.0
+%define pki_core_version           10.0.2
+%define pki_kra_version            10.0.2
+%define pki_ocsp_version           10.0.2
+%define pki_ra_version             10.0.2
+%define pki_tks_version            10.0.2
+%define pki_tps_version            10.0.2
+%define pki_console_version        10.0.2
 %define tomcatjss_version          7.0.0-4
 %else
 %if 0%{?fedora} >= 17
-%define dogtag_pki_theme_version   10.0.0
+%define dogtag_pki_theme_version   10.0.2
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.1
-%define pki_kra_version            10.0.0
-%define pki_ocsp_version           10.0.0
-%define pki_ra_version             10.0.0
-%define pki_tks_version            10.0.0
-%define pki_tps_version            10.0.0
-%define pki_console_version        10.0.0
+%define pki_core_version           10.0.2
+%define pki_kra_version            10.0.2
+%define pki_ocsp_version           10.0.2
+%define pki_ra_version             10.0.2
+%define pki_tks_version            10.0.2
+%define pki_tps_version            10.0.2
+%define pki_console_version        10.0.2
 %define tomcatjss_version          7.0.0-3
 %else
 %if 0%{?fedora} >= 16
-%define dogtag_pki_theme_version   10.0.0
+%define dogtag_pki_theme_version   10.0.2
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.1
-%define pki_kra_version            10.0.0
-%define pki_ocsp_version           10.0.0
-%define pki_ra_version             10.0.0
-%define pki_tks_version            10.0.0
-%define pki_tps_version            10.0.0
-%define pki_console_version        10.0.0
+%define pki_core_version           10.0.2
+%define pki_kra_version            10.0.2
+%define pki_ocsp_version           10.0.2
+%define pki_ra_version             10.0.2
+%define pki_tks_version            10.0.2
+%define pki_tps_version            10.0.2
+%define pki_console_version        10.0.2
 %define tomcatjss_version          6.0.2
 %else
-%define dogtag_pki_theme_version   10.0.0
+%define dogtag_pki_theme_version   10.0.2
 %define esc_version                1.1.0
 %define jss_version                4.2.6-24
-%define pki_core_version           10.0.1
-%define pki_kra_version            10.0.0
-%define pki_ocsp_version           10.0.0
-%define pki_ra_version             10.0.0
-%define pki_tks_version            10.0.0
-%define pki_tps_version            10.0.0
-%define pki_console_version        10.0.0
+%define pki_core_version           10.0.2
+%define pki_kra_version            10.0.2
+%define pki_ocsp_version           10.0.2
+%define pki_ra_version             10.0.2
+%define pki_tks_version            10.0.2
+%define pki_tps_version            10.0.2
+%define pki_console_version        10.0.2
 %define tomcatjss_version          2.0.0
 %endif
 %endif
@@ -186,6 +186,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Mon Mar  4 2013 Matthew Harmsen <mharmsen@redhat.com> 10.0.1-2
 - TRAC Ticket #517 - Clean up theme dependencies
 - TRAC Ticket #518 - Remove UI dependencies from pkispawn . . .
diff --git a/specs/ipa-pki-theme.spec b/specs/ipa-pki-theme.spec
index 1a190197fb30a69f60b4a2ac8e25db77622b698d..095c7e221e4c9b0a6843745b8ebd0bf82b4f8be5 100644
--- a/specs/ipa-pki-theme.spec
+++ b/specs/ipa-pki-theme.spec
@@ -1,6 +1,6 @@
 Name:             ipa-pki-theme
-Version:          10.0.0
-Release:          1%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Certificate System - IPA PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -115,6 +115,9 @@ cd build
 
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Fri Dec 7 2012 Ade Lee <alee@redhat.com> 10.0.0-1
 - Update to official release for rc1
 
diff --git a/specs/pki-console.spec b/specs/pki-console.spec
index 92a5a37cbd39557ea297197dce0fd417db614ef5..c0f98eea77671c36e016923e668b95691e6e1229 100644
--- a/specs/pki-console.spec
+++ b/specs/pki-console.spec
@@ -1,6 +1,6 @@
 Name:             pki-console
-Version:          10.0.0
-Release:          1%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Certificate System - PKI Console
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -80,6 +80,9 @@ cd build
 
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Fri Dec 7 2012 Ade Lee <alee@redhat.com> 10.0.0-1
 - Update to official release for rc1
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 73c374d8e04af269fcf67e6b2131ba28f15675fe..309944fefc812cddeb8740e64b76cc4b7b5c081c 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -4,8 +4,8 @@ distutils.sysconfig import get_python_lib; print(get_python_lib())")}
 distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
-Version:          10.0.1
-Release:          9%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -1006,6 +1006,9 @@ fi
 
 
 %changelog
+* Fri Apr 5 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Fri Apr 5 2013 Endi S. Dewata <edewata@redhat.com> 10.0.1-9
 - Renamed base/deploy to base/server.
 - Moved pki.conf into pki-base.
diff --git a/specs/pki-migrate.spec b/specs/pki-migrate.spec
index 035392c60e1c2c0f3d630fb6763e51ff29f0edc6..4662c2eeba46d320d24b2aae9c815313ae9258bd 100644
--- a/specs/pki-migrate.spec
+++ b/specs/pki-migrate.spec
@@ -1,6 +1,6 @@
 Name:             pki-migrate
-Version:          10.0.0
-Release:          1%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Red Hat Certificate System - PKI Migration Scripts
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -71,6 +71,9 @@ cd build
 
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Fri Dec 7 2012 Ade Lee <alee@redhat.com> 10.0.0-1
 - Update to official release for rc1
 
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index a72f6064cf74d09e78b008fdd0a2ef351d8a21b3..e39e9449ad19aeb0f95c86495dd02da3d305bff2 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -1,6 +1,6 @@
 Name:             pki-ra
-Version:          10.0.0
-Release:          3%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -195,6 +195,9 @@ fi
 
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Tue Mar 12 2013 Endi S. Dewata <edewata@redhat.com> 10.0.0-3
 - Added python build-time dependency.
 
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index ae145c0573c89b45a58c6f44b1a7c7dc843b16a0..404cd4fd899015f18499616808fcf4b41af1ccc9 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -1,6 +1,6 @@
 Name:             pki-tps
-Version:          10.0.0
-Release:          3%{?dist}
+Version:          10.0.2
+Release:          0.1%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -228,6 +228,9 @@ fi
 
 
 %changelog
+* Wed Mar 27 2013 Endi S. Dewata <edewata@redhat.com> 10.0.2-0.1
+- Updated version number to 10.0.2-0.1.
+
 * Tue Mar 12 2013 Endi S. Dewata <edewata@redhat.com> 10.0.0-3
 - Added python build-time dependency.
 
-- 
1.8.1.4